#ifndef PLUGIN_H
#define PLUGIN_H 1

typedef struct _plugin Plugin;
typedef struct _msg Msg;
typedef struct _inst_plugin Installed_Plugin;

struct _msg
{
   int  id;
   char msg[256];
   char dat[512];
};

struct _plugin
{
   char      *name;
   int        id;
   
   int        ready;
   int        is_toolbar;
   pid_t      pid;
   int        msg_id;
   GList     *windows;
   
   int        dead;
};

struct _inst_plugin
{
   char *path;
   int   active;
};

void flim_plugin_init(void);
void flim_plugin_load_config(void);
void flim_plugin_save_config(void);
void flim_start_plugins(void);
Installed_Plugin *flim_find_plugin(char *path);
void flim_plugin_add(char *path);
void flim_plugin_del(char *path);
void flim_toolbar_plugin_add(char *path);
void flim_toolbar_plugin_del(char *path);
void flim_plugin_update_lists(GtkWidget *toolbar_list, GtkWidget *plugin_list);
Plugin *flim_plugin_start(char *name);
Plugin *flim_plugin_find(char *name);
Plugin *flim_plugin_find_pid(pid_t pid);
void flim_plugin_mark_dead(Plugin *plugin);
void flim_plugin_stop(Plugin *plugin);
void flim_plugin_send(Plugin *plugin, Msg *msg);
void flim_plugin_broadcast(Msg *msg);
void flim_plugin_message(Plugin *plugin, Msg *msg);
void flim_plugin_handle_messages(void);
void flim_plugin_wait(void);

#define MSG(msg, m) g_snprintf((msg).msg, sizeof(msg), (m)); 
#define DAT(msg, d) g_snprintf((msg).dat, sizeof(dat), (m)); 

#endif
