/*
 * This program is original work by San Mehat <nettwerk@valinux.com> .
 * This program is distributed under the GNU General Public License (GPL)
 * as outlined in the COPYING file.
 *
 * Copyright (C) 1999, San Mehat, and VA Linux Systems
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 */

#ifndef _MODULE_HARNESS_H
#define _MODULE_HARNESS_H

#include <config.h>

	
typedef struct nexxus_fd_watcher
	{
	int		fd;
	void	(*cb) (int, void *);
	void	*arg;

	struct nexxus_fd_watcher	*next;
	struct nexxus_fd_watcher	*prev;
	} NEXXUS_FD_WATCHER;

typedef struct nexxus_timer
	{
	unsigned int				alarm_time;
	void								(*cb) (void *);
	void								*arg;
	
	struct nexxus_timer	*next;
	struct nexxus_timer	*prev;
	} NEXXUS_TIMER;

typedef struct vacm_module_list
	{
	char								short_name[16];
	int									minor_version;
	int									major_version;
	char								long_name[255];
	char								desc[1024];
	char								author[1024];
	int									api_version_major;
	int									api_version_minor;

	int									loose_fd;  // FD for communicating with this loose module
	pid_t								loose_pid; // PID of the loose module

	char								ipc_tag[32];

#define MOD_STATE_LOADED				1
#define MOD_STATE_INITIALIZING	2
#define MOD_STATE_RUNNING				3
#define MOD_STATE_STOPPING			4
#define MOD_STATE_UNLOADING			5
	int											state;
	struct vacm_module_list	*next;
	struct vacm_module_list	*prev;
	} VACM_MODULE_LIST;
#endif
