/*
 * This program is original work by San Mehat <nettwerk@valinux.com> .
 * This program is distributed under the GNU General Public License (GPL)
 * as outlined in the COPYING file.
 *
 * Copyright (C) 1999, San Mehat, and VA Linux Systems
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 */

#ifndef _NEXXUS_H
#define _NEXXUS_H

#include <config.h>
#include <nexxus_users.h>

#define NODE_NAME_MAXLENGTH	64
#define MAX_IPC_LENGTH 512

typedef struct	variable_list
	{
	char	*module;						// Module this variable is for. NULL == Global 
	char	*variable_name;			// Variable name
	char	*variable_value;		// Variable value
	
	struct variable_list	*next;
	struct variable_list	*prev;
	} VARIABLE_LIST;

/* Boolean type defines */
typedef int bool_t;
#define BOOL_SET(x) { x = 1;}
#define BOOL_UNSET(x) { x = 0;}
#define	BOOL_INIT 0

/* Something to supress unused param warnings */
#define KNOWN_UNUSED_PARAM(x) { int __bleh; __bleh = (int) x;}
#endif
