/*
 * This program is original work by San Mehat <nettwerk@valinux.com> .
 * This program is distributed under the GNU General Public License (GPL)
 * as outlined in the COPYING file.
 *
 * Copyright (C) 1999, San Mehat, and VA Linux Systems
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 */

#ifndef _NEXXUS_NODES_H
#define _NEXXUS_NODES_H

#include <config.h>
#include <nexxus.h>

typedef struct  nodelist_entry
  {
  char                  node_id[NODE_NAME_MAXLENGTH];
  VARIABLE_LIST         *vars;

  struct nodelist_entry *next;
  struct nodelist_entry *prev;
  } NODE;

typedef struct nodegroup
	{
	char									group_name[GROUP_NAME_MAXLENGTH];
	struct nodelist_entry	*nodelist;

	struct nodegroup			*next;
	struct nodegroup			*prev;
	} NODEGROUP;
#endif
