/*
 * This program is original work by San Mehat <nettwerk@valinux.com> .
 * This program is distributed under the GNU General Public License (GPL)
 * as outlined in the COPYING file.
 *
 * Copyright (C) 1999, San Mehat, and VA Linux Systems
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 */

#include <config.h>

#include <stdio.h>
#include <sys/socket.h>
#include <signal.h>
#include <netinet/in.h>
#include <sys/un.h>
#include <stdlib.h>
#include <sys/time.h>
#include <errno.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <stdarg.h>
#include <nexxus.h>
#include <module_harness.h>
#include <prototypes.h>
#include <pthread.h>
extern int	nexxus_stdout_logging;
static FILE	*emergency_mode = NULL;

int do_nexxus_log_printf(char *module, char *fmt, va_list ap)
{
	char			buffer[255];
	FILE			*logfile = NULL;
	int				rc;
	char			timestamp[255];
	time_t		mytime;
	struct tm	*mytm;

	mytime = time(NULL);
	mytm = localtime(&mytime);
	strftime(timestamp,(sizeof(timestamp)-1),"%T",mytm);

	if (!emergency_mode)
		{
		if (!(logfile = fopen(LOGDIR "/vacm.log","a")))
			{
			nexxus_stdout_logging =1;	
			if (errno == EMFILE)
				{
				printf("[Nexxus] Out of open files. Logging system in emergency mode\n");
				fclose(stdin);
				if (!(emergency_mode = fopen(LOGDIR "/vacm.log","a")))
					printf("[Nexxus] Unable to enable emergency mode (%m)\n");
				logfile = emergency_mode;
				}
			else
				{
				printf("[Nexxus] Error: Unable to create logfile (%m)\n");
				return(-1);
				}
			}
		}
	else
		logfile = emergency_mode;

	rc =vsprintf(buffer,fmt,ap);

	if (logfile)
		{
		if (module)
			fprintf(logfile,"[%s][%s] %s",timestamp,module,buffer);
		else
			fprintf(logfile,"[%s][Nexxus] %s",timestamp,buffer);
		fflush(logfile);
		}

	if (nexxus_stdout_logging)
		{
		if (module)
			fprintf(stdout,"[%s] %s",module,buffer);
		else
			fprintf(stdout,"[Nexxus] %s",buffer);
		}
	if (!emergency_mode)
		fclose(logfile);
	return(rc);
}
