#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <nettmcs.h>
#include <prototypes.h>
#include <config.h>

static MEMHDR	*root = NULL;

void *nettmcs_alloc(unsigned int size, char *label)
{
	char		*chunk;
	MEMHDR	*newhdr;

	size +=sizeof(MEMHDR);
	chunk = (char *) malloc(size);
	memset(chunk, 0, size);
	newhdr = (MEMHDR *) chunk;
	strncpy(newhdr->label, label, 32);
	newhdr->size = (size - sizeof(MEMHDR));

	if (!root)
		root = newhdr;
	else
		{
		MEMHDR *newhdr_scan = root;

		while(newhdr_scan->next)
			newhdr_scan = newhdr_scan->next;
		newhdr_scan->next = newhdr;
		newhdr->prev = newhdr_scan;
		}
	newhdr->dataptr = (chunk + sizeof(MEMHDR));
	return((void *) newhdr->dataptr);
}

void nettmcs_free(void *ptr)
{
	MEMHDR	*hdr = root;

	if (!ptr)
		{
		nexxus_log_printf("NeTTmcs",
													"FATAL! Attempting to free NULL ptr\n");
		abort();
		}
	while(hdr)
		{
		if (ptr == hdr->dataptr)
			break;
		hdr = hdr->next;
		}
	if (!hdr)
		{
		nexxus_log_printf("NeTTmcs",
													"FATAL! Attempting to free non alloced memory!(%p)\n",
													ptr);
		abort();
		}
	if (hdr == root)
		{
		root = hdr->next;
		if (root)
			root->prev = NULL;
		}
	else
		{
		if (hdr->next)
			hdr->next->prev = hdr->prev;
		if (hdr->prev)
			hdr->prev->next = hdr->next;
		}
	free(hdr);
}

void nettmcs_dump()
{
	MEMHDR				*hdr = root;
	unsigned int	total=0;

	nexxus_log_printf("NeTTmcs","Memory Control System Allocation Table Dump\n");
	if (!hdr)
		nexxus_log_printf("NeTTmcs","--No dynamically allocated memory\n");
	while(hdr)
		{
		nexxus_log_printf("NeTTmcs","--[ptr %p][size %-9d][%s]\n",hdr->dataptr, hdr->size, hdr->label);
		total +=hdr->size;
		hdr = hdr->next;
		}
	nexxus_log_printf("NeTTmcs","Dump Complete (total memory dynamically allocated %d bytes)\n",total);
}
