/*
 * This program is original work by San Mehat <nettwerk@valinux.com> and
 * Zac Sprackett <zac@sprackett.com>.
 * This program is distributed under the GNU Lesser General Public License
 * (LGPL).
 *
 * Copyright (C) 1999, San Mehat, Zac Sprackett and VA Linux Systems
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */
#ifndef _HAS_UTIL_H
#define _HAS_UTIL_H

#include <stdlib.h>
typedef struct _list_element
{
	void *data;
	struct _list_element *next;
} List_Element;

typedef struct _list
{
	int size;

	int (*match)(const void *key1, const void *key2);
	void (*destroy)(void *data);

	List_Element *head;
	List_Element *tail;
} List;

/* Public Interface for linked lists */
void list_init(List *list, void (*destroy)(void *data));
void list_destroy(List *list);
int list_ins_next(List *list, List_Element *element, const void *data);
int list_rem_next(List *list, List_Element *element, void **data);
int list_rem(List *list, List_Element *element, void **data, List_Element **ptr);

#define list_size(list) ((list)->size)
#define list_head(list) ((list)->head)
#define list_tail(list) ((list)->tail)
#define list_is_head(list,element) ((element) == (list)->head ? 1:0)
#define list_is_tail(list,element) ((element) == (list)->tail ? 1:0)
#define list_data(element) ((element)->data)
#define list_next(element) ((element)->next)

#endif
