/*
 * This program is original work by San Mehat <nettwerk@valinux.com> .
 * This program is distributed under the GNU General Public License (GPL)
 * as outlined in the COPYING file.
 *
 * Copyright (C) 1999, San Mehat, and VA Linux Systems
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 *  with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#ifndef _RSH_MODULE_HARNESS_H
#define _RSH_MODULE_HARNESS_H

#include <config.h>

#define TRUE  1
#define FALSE !TRUE
#define SHELL 514
#define KNOWN_UNUSED_PARAM(x) { int __bleh; __bleh = (int) x;}

typedef struct slave
	{
	pid_t					pid;
	int						nodecount;

	int						read_sock;
	int						write_sock;

	struct slave	*next;
	struct slave	*prev;
	} SLAVE;

typedef struct nodelist
	{
	char         	node_id[64];
	struct slave	*slave;
	
  struct nodelist *next;
  struct nodelist *prev;
	} NODELIST;

#endif
