typedef unsigned short u16;
   /*
    *     * FCS lookup table as calculated by the table generator.
    *         */
   static u16 fcstab[256] = {
      0x0000, 0x1189, 0x2312, 0x329b, 0x4624, 0x57ad, 0x6536, 0x74bf,
      0x8c48, 0x9dc1, 0xaf5a, 0xbed3, 0xca6c, 0xdbe5, 0xe97e, 0xf8f7,
      0x1081, 0x0108, 0x3393, 0x221a, 0x56a5, 0x472c, 0x75b7, 0x643e,
      0x9cc9, 0x8d40, 0xbfdb, 0xae52, 0xdaed, 0xcb64, 0xf9ff, 0xe876,
      0x2102, 0x308b, 0x0210, 0x1399, 0x6726, 0x76af, 0x4434, 0x55bd,
      0xad4a, 0xbcc3, 0x8e58, 0x9fd1, 0xeb6e, 0xfae7, 0xc87c, 0xd9f5,
      0x3183, 0x200a, 0x1291, 0x0318, 0x77a7, 0x662e, 0x54b5, 0x453c,
      0xbdcb, 0xac42, 0x9ed9, 0x8f50, 0xfbef, 0xea66, 0xd8fd, 0xc974,
      0x4204, 0x538d, 0x6116, 0x709f, 0x0420, 0x15a9, 0x2732, 0x36bb,
      0xce4c, 0xdfc5, 0xed5e, 0xfcd7, 0x8868, 0x99e1, 0xab7a, 0xbaf3,
      0x5285, 0x430c, 0x7197, 0x601e, 0x14a1, 0x0528, 0x37b3, 0x263a,
      0xdecd, 0xcf44, 0xfddf, 0xec56, 0x98e9, 0x8960, 0xbbfb, 0xaa72,
      0x6306, 0x728f, 0x4014, 0x519d, 0x2522, 0x34ab, 0x0630, 0x17b9,
      0xef4e, 0xfec7, 0xcc5c, 0xddd5, 0xa96a, 0xb8e3, 0x8a78, 0x9bf1,
      0x7387, 0x620e, 0x5095, 0x411c, 0x35a3, 0x242a, 0x16b1, 0x0738,
      0xffcf, 0xee46, 0xdcdd, 0xcd54, 0xb9eb, 0xa862, 0x9af9, 0x8b70,
      0x8408, 0x9581, 0xa71a, 0xb693, 0xc22c, 0xd3a5, 0xe13e, 0xf0b7,
      0x0840, 0x19c9, 0x2b52, 0x3adb, 0x4e64, 0x5fed, 0x6d76, 0x7cff,
      0x9489, 0x8500, 0xb79b, 0xa612, 0xd2ad, 0xc324, 0xf1bf, 0xe036,
      0x18c1, 0x0948, 0x3bd3, 0x2a5a, 0x5ee5, 0x4f6c, 0x7df7, 0x6c7e,

      0xa50a, 0xb483, 0x8618, 0x9791, 0xe32e, 0xf2a7, 0xc03c, 0xd1b5,
      0x2942, 0x38cb, 0x0a50, 0x1bd9, 0x6f66, 0x7eef, 0x4c74, 0x5dfd,
      0xb58b, 0xa402, 0x9699, 0x8710, 0xf3af, 0xe226, 0xd0bd, 0xc134,
      0x39c3, 0x284a, 0x1ad1, 0x0b58, 0x7fe7, 0x6e6e, 0x5cf5, 0x4d7c,
      0xc60c, 0xd785, 0xe51e, 0xf497, 0x8028, 0x91a1, 0xa33a, 0xb2b3,
      0x4a44, 0x5bcd, 0x6956, 0x78df, 0x0c60, 0x1de9, 0x2f72, 0x3efb,
      0xd68d, 0xc704, 0xf59f, 0xe416, 0x90a9, 0x8120, 0xb3bb, 0xa232,
      0x5ac5, 0x4b4c, 0x79d7, 0x685e, 0x1ce1, 0x0d68, 0x3ff3, 0x2e7a,
      0xe70e, 0xf687, 0xc41c, 0xd595, 0xa12a, 0xb0a3, 0x8238, 0x93b1,
      0x6b46, 0x7acf, 0x4854, 0x59dd, 0x2d62, 0x3ceb, 0x0e70, 0x1ff9,
      0xf78f, 0xe606, 0xd49d, 0xc514, 0xb1ab, 0xa022, 0x92b9, 0x8330,
      0x7bc7, 0x6a4e, 0x58d5, 0x495c, 0x3de3, 0x2c6a, 0x1ef1, 0x0f78
   };

#define PPP_INITFCS 0xffff
#define PPP_GOODFCS 0xf0b8
#define PPP_FCS(fcs, c) (((fcs) >> 8) ^ fcstab[((fcs) ^ (c)) & 0xff])

struct bmchdr
  {
  unsigned char   field1            __attribute__((packed));
  unsigned char   hdr_len           __attribute__((packed));
  unsigned char   seq               __attribute__((packed));
  unsigned char   field2            __attribute__((packed));

  unsigned int    res_constant      __attribute__((packed));
  unsigned char   field_version     __attribute__((packed));
  unsigned char   sati              __attribute__((packed));
  unsigned short  res1              __attribute__((packed));
  unsigned int    ssn               __attribute__((packed));
  unsigned char   md5[16]           __attribute__((packed));
  };

struct reqhdr
  {
  unsigned char msg_type;
  unsigned char msg_length;
  unsigned char reserved;
  /* IPMB message goes here */
  };

#define PPPINITFCS16    0xffff  /* Initial FCS value */
#define PPPGOODFCS16    0xf0b8  /* Good final FCS value */

typedef struct type_length
  {
  unsigned char num_bytes :6 __attribute__((packed));
  unsigned char type_code :6 __attribute__((packed));
  } TL;

typedef struct variable_binding
  {
  unsigned char   guid[16]          __attribute__((packed));
  unsigned short  sequence          __attribute__((packed));
  unsigned int    local_timestamp   __attribute__((packed));
  unsigned short  utc_offset        __attribute__((packed));
  unsigned char   trap_src_type     __attribute__((packed));
  unsigned char   event_src_type    __attribute__((packed));
  unsigned char   event_severity    __attribute__((packed));
  unsigned char   sensor_device     __attribute__((packed));
  unsigned char   sensor_number     __attribute__((packed));
  unsigned char   entity            __attribute__((packed));
  unsigned char   entity_instance   __attribute__((packed));

  unsigned char   event_data1       __attribute__((packed));
  unsigned char   event_data2       __attribute__((packed));
  unsigned char   event_data3       __attribute__((packed));
  unsigned char   event_data4       __attribute__((packed));
  unsigned char   event_data5       __attribute__((packed));
  unsigned char   event_data6       __attribute__((packed));
  unsigned char   event_data7       __attribute__((packed));
  unsigned char   event_data8       __attribute__((packed));

  unsigned char   language          __attribute__((packed));
  unsigned int    response_format   __attribute__((packed));
  unsigned short  hwid              __attribute__((packed));

  /* response data follows */
  }VAR_BIND;

typedef struct ipmb_reqhdr
  {

#define SBT2_SLAVE_ADDRESS 0x20
  unsigned char rs_slave_addr;
  
  unsigned char lun:2;
  
	// The network function codes
#define CHASSIS_REQUEST   0x00
#define CHASSIS_RESPONSE  0x01
#define BRIDGE_REQUEST    0x02
#define BRIDGE_RESPONSE   0x03
#define SENSOR_REQUEST    0x04
#define SENSOR_RESPONSE   0x05
#define APP_REQUEST       0x06
#define APP_RESPONSE      0x07
#define FIRMWARE_REQUEST  0x08
#define FIRMWARE_RESPONSE 0x09
#define STORAGE_REQUEST   0x0A
#define STORAGE_RESPONSE  0x0B
  unsigned char net_fn:6;

  unsigned char cksum1;

#define SBT2_APPLICATION_SLAVE_ADDRESS 0xC2
  unsigned char rq_slave_addr;
  
  unsigned char rqseq;
  unsigned char cmd;
  }IPMB_REQHDR; /* After this there are x data bytes, then a checksum */

#define CMD_GET_CHASSIS_CAPABILITIES      0x00
#define CMD_GET_CHASSIS_STATUS            0x01
#define CMD_CHASSIS_CONTROL               0x02
#define CMD_IDENTIFY_CHASSIS              0x04
#define CMD_GET_FRU_INV_AREA_INFO         0x10
#define CMD_SET_ACPI_POWER_STATE          0x06
#define CMD_GET_ACPI_POWER_STATE          0x07
#define CMD_READ_FRU_INV_DATA             0x11
#define CMD_WRITE_FRU_INV_DATA            0x12
#define CMD_GET_SDR_REPOSITORY_INFO       0x20
#define CMD_GET_SDR_REPOSITORY_ALLOC_INFO 0x21
#define CMD_RESERVE_SDR_REPOSITORY        0x22
#define CMD_GET_SDR                       0x23
#define CMD_GET_SDR_REPOSITORY_TIME       0x28
#define CMD_GET_SENSOR_READING            0x2D
#define CMD_GET_SEL_INFO                  0x40
#define CMD_GET_SEL_ALLOC_INFO            0x41
#define CMD_RESERVE_SEL                   0x42
#define CMD_GET_SEL_ENTRY                 0x43
#define CMD_DEL_SEL_ENTRY                 0x46
#define CMD_CLEAR_SEL                     0x47
#define CMD_GET_SEL_TIME                  0x48
#define CMD_SUBMIT_PASSWORD               0x72
#define CMD_SET_BIOS_FLAGS                0x7c
#define CMD_GET_BIOS_FLAGS                0x7d
#define CMD_GET_DEVICE_ID                 0x01
#define CMD_GET_CURRENT_POWER_STATE       0xdc

typedef struct power_state_response
	{
	unsigned char cc;

	unsigned char sps_enumeration				:7;
	unsigned char sps_reserved					:1;

	unsigned char dps_enumeration				:7;
	unsigned char dps_reserved					:1;
	} POWER_STATE_RESPONSE;

typedef struct power_state_set
	{
	unsigned char sps_enumeration           :7;
	unsigned char sps_set_power       :1;
#define SPS_POWER_UNCHANGED   0x7f

	unsigned char dps_enumeration           :7;
	unsigned char dps_set_power       :1;
#define DPS_POWER_OFF         0x00
#define DPS_POWER_ON          0x01
#define DPS_POWER_UNKNOWN     0x03
#define DPS_POWER_UNCHANGED   0x7f
	} ACPI_POWER_STATE_SET;

