/*
 * This program is original work by San Mehat <nettwerk@valinux.com> .
 * This program is distributed under the GNU General Public License (GPL)
 * as outlined in the COPYING file.
 *
 * Copyright (C) 1999, San Mehat, and VA Linux Systems
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 *  with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * VACM Remote System Status Module include
 */

#ifndef _VACM_SYS_STATD_H
#define _VACM_SYS_STATD_H

#include <config.h>

#ifdef OPENSSL
#include <openssl/rsa.h>
#include <openssl/crypto.h>
#include <openssl/x509.h>
#include <openssl/pem.h>
#include <openssl/ssl.h>
#include <openssl/err.h>
#endif

#define TRUE  1
#define FALSE !TRUE
#define KNOWN_UNUSED_PARAM(x) { int __bleh; __bleh = (int) x;}

#define NETWORK_PORT  3373

typedef struct nexxus
	{
  int							sock;    /* Communications socket for node */
	int							authenticated;
#ifdef OPENSSL
  SSL							*ssl;
  X509						*cert;
#endif
	} NEXXUS;

#define REQUEST_MEM			1
#define REQUEST_CPU			2
#define REQUEST_UPTIME	3
#define REQUEST_FS			4
#define REQUEST_WHO			5
#define REQUEST_PS			6
#define REQUEST_VERSION	7
#define REQUEST_APM			8
#define REQUEST_INT			9
#define REQUEST_IO			10
#define REQUEST_DMA			11
#define REQUEST_SWAP		12

#endif
